module SvcParty

  class ApiResponseHandler

    def self.error(ex)
      SvcParty::ApiResponse.new(false, 500, ex.message)
    end

    def initialize(response)
      @response = response
    end

    def call
      api_response
    end

    private

    def api_response
      code = @response.response.code.to_i
      response = @response.parsed_response

      return SvcParty::ApiResponse.new(true, code, response) if (200..299).cover? code
      return SvcParty::ApiResponse.new(true, code, @response.response.header['location']) if code == 302

      SvcParty::ApiResponse.new(false, code, response)
    end
  end
end